########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../report.4gs/lib_eror.4gl  1.3  Delta: 2/20/91
########################################################################

# globals "globals.4gl"

define
    scratch char(512),               # Defined because no 'globals.4gl'
    err_lang char(3),                # error language
    err_prep char(1),                # Y/null Error cursor prepared?
    err_mod  char(8),                # error module
    err_prog char(8),                # error program
    err_num  smallint,               # error number
    one_liner char(60),              # one line error message
    tech_msg char(100),              # technical description of error
    errstat integer                  # status variable upon entry

######################################################################
function lib_error(err_module, err_program, err_number, tech_message)
######################################################################
# This is the fourgen programmer/user definable error routine.
#
    define
        err_module  char(8),    # module name
        err_program char(8),    # program name within the module
        err_number  smallint,   # error number within the program
        tech_message char(100), # technical error message
        c           char(1)     # entry char

    # Set the static variables
    let errstat = status
    if errstat = 0 then let errstat = sqlca.sqlcode end if
    let err_mod = err_module
    let err_prog = err_program
    let err_num = err_number
    let tech_msg = tech_message

    # If the error number is 0, then the user selected control-e
    # during input.  Don't allow them to choose the error to edit.
    if err_num = 0
      then return
    end if

    whenever error continue
    open window l_errwin at 22, 8 with 2 rows, 66 columns
        attribute (border, white)
    whenever error call error_handler

    display " Error:" at 1,1

    if one_liner is null
      then call er_read(err_mod, err_prog, err_num)
    end if

    display " ",one_liner clipped," " at 1,10 attribute(reverse)

    prompt "Press [ENTER] to continue" for char c
    close window l_errwin

    # Reset error condition
    let err_mod = ""
    let err_prog= ""
    let err_num = 0
    let one_liner = ""
    let tech_msg = ""
    return
end function
# lib_error()

#####################################################################
function er_read(err_mod, err_prog, err_num)
#####################################################################
# This function reads the error text from the user defined table,
# or from the system defined table if no data exists in the user
# defined error text table.
#
    define
        err_mod  char(8),                # error module (passed)
        err_prog char(8),                # error program (passed)
        err_num  smallint                # error number (passed)

    # Prepare the cursors upon first call
    if err_prep is null
    then
        let scratch = "select err_line, userdef from stxerorh",
          " where err_module = ?",
          " and err_program = ?",
          " and err_number = ?",
          " and language = \"ENG\"",
          " order by userdef desc"
        prepare onlspec from scratch
        declare s_erorh cursor for onlspec

        let err_prep = "Y"
    end if

    # Fetch the oneliner
    open s_erorh using err_mod, err_prog, err_num
    fetch s_erorh into one_liner

    # Check for notfound condition
    if sqlca.sqlcode = notfound
    then
        # Try to read this new error condition from the error file
        if    err_mod = "lib_scr"
          and err_prog = "error"
          and err_num = 1
        then
            # loop situation
            let one_liner = "Unknown - Cannot locate error text."
            return
        end if
        call er_read("lib_scr","error",1)
        return
    end if

    # No use leaving the cursors open
    close s_erorh

end function
# er_read()

######################################################################
function err_line(errorline)
######################################################################
# This function allows you to programatically change the 'one liner'
# error message.  This is useful for standard errors (like lookups)
# that you would like different text for the one liner.
#
    define
        errorline char(60)
    let one_liner = errorline
end function
# err_line
