########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/autonext.4gl  1.6  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    arr_mesgs array[2] of record    # Message text
        mssg_text char(132)
    end record,
    mssg_prep char(1)               # Y/null Message cursor prepared?

###############################################################
function auto_next(table_name,column_name)
# returns the next control number
###############################################################
# This function increments a column in a control table by 1,
# locks the column (fetch first) in the table, then builds the sql
# script to increment the column based upon column_name.  If it 
# cannot obtain a lock within 5 seconds, it then pulls up a window
# with the message:
#
#    "Waiting for table: (table_name) to become available..."
#
# It then goes into a try/sleep/try/sleep loop until it can get that 
# lock after which it increments the column.
#

define
    stat_flag       smallint,
    find_num        char(128),
    update_1        char(128),
    number          integer,
    table_name      char(8),
    column_name     char(14)

    if mssg_prep is null then
       call fg_getmsg("lib_std","autonext",1)  #1: " Waiting for table: "
       let arr_mesgs[1].mssg_text = scratch
       call fg_getmsg("lib_std","autonext",2)  #2: " to become available..."
       let arr_mesgs[2].mssg_text = scratch
       let mssg_prep = "Y"
    end if

    let stat_flag = true

    let find_num = "select ", column_name, " from ", table_name

    let update_1 = "update ", table_name, " set ",
                    column_name, " = ", column_name, " + 1"

    prepare select_1 from find_num
    prepare update_2 from update_1

    whenever error continue
    declare c_cursor cursor for select_1
    open c_cursor
    fetch c_cursor into number
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        let sqlca.sqlcode = 0
        let stat_flag = false
        open window wt_win at 2,4 with 1 rows, 60 columns
            attribute(white,border)
        display arr_mesgs[1].mssg_text clipped,table_name,
                arr_mesgs[2].mssg_text clipped at 1,1
        display arr_mesgs[1].mssg_text clipped,table_name,
                arr_mesgs[2].mssg_text clipped at 1,1
        sleep 5
    end if
    while stat_flag = false
        whenever error continue
        open c_cursor
        fetch c_cursor into number
        whenever error call error_handler
        if sqlca.sqlcode = 0
        then
            exit while
        else
            let sqlca.sqlcode = 0
            sleep 5
        end if
    end while
    if stat_flag = false
    then
        close window wt_win
    end if
    execute update_2
    if number is null then let number = 0 end if
    let number = number + 1
    close c_cursor
    return number

end function
# auto_next()
