######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/err_hand.4gl  1.1  Delta: 11/23/90
######################################################################

define
  recurs char(1)  # (Y or null) Is this a recursive call?

######################################################################
function error_handler()
######################################################################
# This is where the program ends up if it detects a fatal error.
# Error_handler's job is to present the user with the fact that they
# have encountered a fatal error, and give them the tools present
# in lib_error() to understand and document the error.
# This is also the place that known fatal errors can be identified
# and passed onto lib_error for further explanation.
#
    define
        err_num smallint  # Error number to pass to lib_error

    # If a fatal error occurs in lib_error, there could be
    # a recursive error condition.
    # Exit program if a recursive situation is found.
    if recurs is null
      then let recurs = "Y"
      else exit program(1)
    end if

    # -329 is the killer.  Can't open the database.  If you
    # can't do this, then you can't read the error text, so
    # at least plug the one_liner with the problem.
    if  sqlca.sqlcode = -329 
     or sqlca.sqlcode = -349 
      then call err_line("Cannot open the database.")
    end if

    call lib_error("lib_scr","errhand",1,"")
    exit program (1)
end function
# error_handler()
