########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/fg_mesg.4gl  1.4  Delta: 3/23/91
########################################################################

globals "globals.4gl"

define
    mssg_lang char(3),                # message language
    mssg_mod  char(8),                # message module
    mssg_prog char(8),                # message program
    mssg_num  smallint,               # message number
    one_liner char(132),              # one line message
    mssgstat integer,                # status variable upon entry
    mssg_prep char(1)                  # Y/null Message cursor prepared?

######################################################################
function fg_getmsg(mssg_module, mssg_program, mssg_number)
# returning value into scratch
######################################################################
# This is the fourgen programmer message routine.
#
    define
        mssg_module  char(8),    # module name
        mssg_program char(8),    # program name within the module
        mssg_number  smallint    # message number within the program

    # Trap fatal errors
    whenever error call error_handler

    # Set the static variables
    let mssgstat = status
    if mssg_lang is null
      then let mssg_lang = get_scrlib("language") end if
    if mssgstat = 0 then let mssgstat = sqlca.sqlcode end if
    let mssg_mod = mssg_module
    let mssg_prog = mssg_program
    let mssg_num = mssg_number

    call mssg_read(mssg_mod, mssg_prog, mssg_num,mssg_lang)
    if mssgstat = notfound
    then
        # try one more time with default of "English"
        if mssgstat = notfound
        then
            let mssg_lang = "ENG"
            let mssgstat = 0
            call mssg_read(mssg_mod, mssg_prog, mssg_num,mssg_lang)
            if mssgstat = notfound
            then
               let mssg_lang = get_scrlib("language") # back to orig
               let one_liner = mssg_lang, " msg #: ", mssg_num,
                   " not found" clipped
            end if
        end if
    end if

    let scratch = one_liner clipped

end function
# end fg_getmsg()

######################################################################
function fg_message(mssg_module, mssg_program, mssg_number)
# returning message line
######################################################################
# This is the fourgen programmer message routine.
#
    define
        mssg_module  char(8),    # module name
        mssg_program char(8),    # program name within the module
        mssg_number  smallint    # message number within the program

    # Trap fatal errors
    whenever error call error_handler

    # Set the static variables
    let mssgstat = status
    if mssg_lang is null
      then let mssg_lang = get_scrlib("language") end if
    if mssgstat = 0 then let mssgstat = sqlca.sqlcode end if
    let mssg_mod = mssg_module
    let mssg_prog = mssg_program
    let mssg_num = mssg_number

    call mssg_read(mssg_mod, mssg_prog, mssg_num,mssg_lang)
    if mssgstat = notfound
    then
        # try one more time with default of "English"
        if mssgstat = notfound
        then
            let mssg_lang = "ENG"
            let mssgstat = 0
            call mssg_read(mssg_mod, mssg_prog, mssg_num,mssg_lang)
            if mssgstat = notfound
            then
               let mssg_lang = get_scrlib("language") # back to orig
               let one_liner = mssg_lang, " msg #: ", mssg_num,
                   " not found" clipped
            end if
        end if
    end if

    return one_liner

end function
# end fg_message()

#####################################################################
function mssg_read(mssg_mod, mssg_prog, mssg_num,mssg_lang)
#####################################################################
# This function reads the message text from the system defined table
#
    define
        mssg_mod  char(8),                # message module (passed)
        mssg_prog char(8),                # message program (passed)
        mssg_lang char(3),                # message language
        tech_msg  char(100),              # technical message
        sql_stmt  char(256),
        mssg_num  smallint                # message number (passed)

    # Prepare the cursors upon first call
    if mssg_prep is null
    then
        let sql_stmt = "select message from stxmssgr",
          " where mssg_module = ?",
          " and mssg_program = ?",
          " and mssg_number = ?",
          " and language = ?"
        prepare onlspec from sql_stmt
        declare s_mesgh cursor for onlspec

        let mssg_prep = "Y"
    end if

    # Fetch the oneliner
    open s_mesgh using mssg_mod, mssg_prog, mssg_num, mssg_lang
    fetch s_mesgh into one_liner

    # Check for notfound condition
    if sqlca.sqlcode = notfound
    then
        let mssgstat = notfound
        return
    end if


    # No use leaving the cursors open
    close s_mesgh

end function
# mssg_read()

#####################################################################
function fg_mssg(mssg_number)
#####################################################################
# This function provides a shortcut to fg_message().  It uses progid
# to determine the module and program name.
#
    define
        mssg_number  smallint,   # mssgor number passed
        mssg_mod     char(8),    # mssgor module
        mssg_prog    char(8)     # mssgor program

    # Trap fatal mssgors
    whenever error call error_handler

    # Get the module and program from progid
    call get_mod() returning mssg_mod, mssg_prog

    # Pass control to the main Message handling routine
    call fg_getmsg(mssg_mod, mssg_prog, mssg_number)

end function
# fg_mssg()
