######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/fg_table.4gl  1.3  Delta: 1/22/91
######################################################################

globals "globals.4gl"

######################################################################
function fg_tables()
######################################################################
# This function builds the tables that the code generator requires.
#
    define
        dbname char(18),  # Database name
        tmp_str char(100),# Scratch string
        ret integer       # Return value

    # Trap fatal errors
    whenever error call error_handler

    let dbname = get_scrlib("dbname")

    let tmp_str = "About to add the required FourGen tables to the '",
      dbname clipped, "' database."

    display tmp_str at 1,2
    prompt " Press [ENTER] to continue, [DEL] to cancel: " for tmp_str
	if int_flag
	then
		exit program(0)
    end if

	let int_flag = 0
    let tmp_str = "$fg/bin/mktables -d ", get_scrlib("dbname")
    run tmp_str returning ret

    if ret != 0
    then
        let tmp_str = "$fg/bin/mktables failed with an ",
          ret using "exit status of: <<<"
        call lib_error("lib_scr","mktables",1,tmp_str)
        exit program(1)
    end if

end function
# fg_tables()
