#####################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/fg_usern.4gl  1.2  Last Delta: 11/23/90
#####################################################################


# static storage for the user name
define
    user_name char(20)

#####################################################################
function fg_username()
# return user's login name
#####################################################################
# This function selectes the user name using a select with the table
# systables. It returns the user's name if found, otherwise UNKNOWN.
#
# The database must first be selected to use this function.
#
    # Trap fatal errors
    whenever error call error_handler

    # get the user login name by selecting user from a system table
    if user_name is null
    then
        whenever error continue
        select user into user_name from systables where tabid = 1
        whenever error call error_handler

        # make sure a user name was selected
        if sqlca.sqlcode or user_name is null
          then let user_name = "UNKNOWN"
        end if
    end if

    # return the users name
    return user_name

end function
# end fg_username()
