######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/get_arg.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

######################################################################
function get_arg(arg_name)
# returning true/false based on if that arg_name is available
######################################################################
# This function parses the command line, and returns true or false
# depending on if the argument exists on the command line.
# If the argument exists, and is not the last on the command line,
# then 'scratch' is filled with the next argument.
# If an arg_name of "-d" is passed to this function, and the program
# was called using:
# progname.4gi -d sample
# then get_arg() would return true, and the value of "sample" could be
# found in the scratch variable.
#
    define
        arg_name char(20),  # argument name
        n smallint          # generic counter

    # Trap fatal errors
    whenever error call error_handler

    # Search through all arguments
    for n = 1 to num_args()
        if arg_val(n) = arg_name
        then
            if n < num_args() then let scratch = arg_val(n + 1) end if
            return true
        end if
    end for

    # Arg name not found on command line
    return false

end function
# get_arg()
