######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/is_trx.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

define
  using_trx char(1)  # "Y/N"

######################################################################
function is_trx()
# returning true if we're using database transactions
######################################################################
# This function is called if the programmer needs to know if
# database transactions are running in this database.
#
    # Trap fatal errors
    whenever error call error_handler

    # Initialize upon first call to this function
    if using_trx is null
    then
        # If we get an error when "begin work" is issued, then
        # we're not using database transactions.
        whenever error continue
        begin work
        whenever error call error_handler
        if sqlca.sqlcode = 0
        then
            commit work
            let using_trx = "Y"
        else
            let using_trx = "N"
        end if
    end if

    if using_trx = "Y"
      then return true
      else return false
    end if
end function
# is_trx()
