######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/is_turbo.4gl  1.2  Delta: 11/26/90
######################################################################

globals "globals.4gl"

define
  using_turbo char(1), # "Y/N"
  using_4_0 char(1)    # "Y/N" Using the 4.0 engine now?

######################################################################
function is_turbo()
# returning true if we're using the turbo (or online) engine
######################################################################
# This function is called if the programmer needs to do something
# different depending on if the turbo/online engine is running.
#
    # Trap fatal errors
    whenever error call error_handler

    # Initialize upon first call to this function
    if using_turbo is null
    then
        select rowid from syscolumns
          where colname = "dirpath" and tabid = 1
        if sqlca.sqlcode = notfound
          then let using_turbo = "Y"
          else let using_turbo = "N"
        end if
    end if

    if using_turbo = "Y"
      then return true
      else return false
    end if
end function
# is_turbo()

######################################################################
function is_4_0()
# returning true if we're using a 4.0 database
######################################################################
# This function is called if the programmer needs to do something
# different depending on if the database engine is version 4.0.
#
    # Initialize upon first call to this function
    if using_4_0 is null
    then
        select rowid from systables
          where tabname = "sysconstraints"
        if sqlca.sqlcode = notfound
          then let using_4_0 = "N"
          else let using_4_0 = "Y"
        end if
    end if

    if using_4_0 = "Y"
      then return true
      else return false
    end if
end function
# is_4_0()
