######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/round.4gl  1.2  Delta: 1/31/91
######################################################################

######################################################################
function round(type, value)
# returns rounded value, depending on value type
# returns null if value is null
######################################################################
#
# types:
#     a) decimal for normal money amounts.  currently two places
#     b) decimal for more precise money amounts.  currently three places
#     c) decimal for physical quantities.  currently three places
#     d) decimal for hours.  currently two places
#     e) decimal for rates.  currently three places
#     f) decimal for even more precise money amounts. currently four places
#
    define
        type char(1),
        value  decimal(16),
        char_value char(18)

    # Trap fatal errors
    whenever error call error_handler

    case
      when value is null let char_value = null
      when type = "a" let char_value = value using "--------------&.&&"
      when type = "b" let char_value = value using "-------------&.&&&"
      when type = "c" let char_value = value using "-------------&.&&&"
      when type = "d" let char_value = value using "--------------&.&&"
      when type = "e" let char_value = value using "-------------&.&&&"
      when type = "f" let char_value = value using "------------&.&&&&"
      otherwise let char_value = value
    end case

    return char_value

end function
# round()
