######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/sq_rt.4gl  1.1  Delta: 11/23/90
######################################################################

######################################################################
function sq_rt(n)
# returning the square root of n
######################################################################
# This function returns the square root of the number passed
#
    define
        n decimal,            # number to get the sq_rt of 
        done smallint,        # (boolean) Are we done?
        x decimal(13,6),      # temporary internal variable
        x_next decimal(13,6)  # temporary internal variable

    # Trap fatal errors
    whenever error call error_handler

    # Can't deal with negatives or nulls
    if n <= 0 or n is null then return 0 end if

    # Main sq_rt loop
    let x = 1
    let done = false
    while not done
        let x_next = x - (((x * x) - n) / (2 * x))
        if absolute(x - x_next) < .001
          then let done = true
          else let x = x_next
        end if
    end while

    return x_next
end function
# sq_rt()
