######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/tblexist.4gl  1.1  Delta: 11/23/90
######################################################################

######################################################################
function table_exist(table_name)
# returns true if the specified table exists
######################################################################
#
    define
        table_name char(18)

    # Trap fatal errors
    whenever error call error_handler

    # Formonly tables exist by definition
    if table_name = "formonly" or table_name = "FORMONLY"
    then
        return true
    end if

    select systables.tabname into table_name from systables
        where systables.tabname = table_name

    if sqlca.sqlcode = notfound
    then
        let status = 0
        return false
    else
        return true
    end if

end function
# table_exist()

######################################################################
function col_exist(table_name, col_name)
# returns true if the specified column exists
######################################################################
#
    define
        table_name char(18),
        col_name char(18)

    # Formonly tables exist by definition
    if table_name = "formonly" or table_name = "FORMONLY"
    then
        if col_name is null or col_name = " "
        then
            return false
        else
            return true
        end if
    end if

    select systables.tabname into table_name from systables, syscolumns
    where syscolumns.colname = col_name and
        systables.tabname = table_name and
        syscolumns.tabid = systables.tabid

    if sqlca.sqlcode = notfound
    then
        let status = 0
        return false
    else
        return true
    end if

end function
# col_exist()

######################################################################
function tabcol_exist(tabcol_name)
# returns true if the specified table.column exists
######################################################################
#
    define
        tabcol_name char(38),
        n           smallint

    for n = 1 to 19
        if tabcol_name[n] = "."
        then
            exit for
        end if
    end for

    if not table_exist(tabcol_name[1, n - 1])
    then
        return false
    end if

    if not col_exist(tabcol_name[1, n - 1], tabcol_name[n + 1, 38])
    then
        return false
    end if

    return true

end function
# tabcol_exist()
