######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/wait_win.4gl  1.1  Delta: 11/23/90
######################################################################

globals "globals.4gl"

######################################################################
function wait_on(wait_mssg)
######################################################################
# This function opens a window before calling please_wait().
# It is run when you don't want to wipe out the data on line #2.
# You must call wait_off when you're done to close the window.
#
    define
        wait_mssg char(72)

    # Trap fatal errors
    whenever error call error_handler

    # Prevent errors on recursive calls
    whenever error continue
    open window wait_win at 2,3 with 2 rows, 76 columns
      attribute(white)
    whenever error call error_handler

    display wait_mssg at 1,2
    call please_wait()
    
end function
# wait_on()

######################################################################
function wait_off()
######################################################################
# This function closes the window that was opened during wait_on().
#
    whenever error continue
    close window wait_win
    whenever error call error_handler
end function
# wait_off()
